/*
 * bitmap.c -- part of the C sources generated from the CDL3 sources,
 *              used to bootstrap CDL3
 * Copyright (C) 2000  C.H.A. Koster
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "cdl3rts.h"
#include "predef.h"


static char* module_name = "bitmap";

/*
** GLOBALS
*/

	static long undefined[] = {1023};
long G_bitmap_BITMAP_NR79[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR80[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR81[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR82[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR83[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR84[] = {Tag(1,1)};
long G_bitmap_BITMAP_NR85[] = {Tag(1,1)};
long G_bitmap_TEXT_NR86[] = {Tag(1,T_TEXT),1,(long)" "};

/*
** ATTACH/DETACH/EQUAL
*/
/****BITMAP(bitmap)****/

int EQ_Mbitmap_T1(x,y)
value x;
value y;
{
  if (Alternative(x)!=Alternative(y)) return 0;
  switch(Alternative(x))
    {
       case 0:
         return (Part(x,1) == Part(y,1))&&EQ_Mbitmap_T1(Part(x,2),Part(y,2));
       case 1:
         return 1;
    };
  return 0;
}

int W_Mbitmap_T1(x)
value x;
{
  switch(Alternative(x))
    {
       case 0:
W_INT(Part(x,1));
WRITE(" ");
WRITE("and ");
W_Mbitmap_T1(Part(x,2));
WRITE(" ");
       case 1:
WRITE("end ");
    };
  return 0;
}

int XD_Mbitmap_T1(x)
value x;
{
#ifdef COUNT
  frees++;
#endif
  switch (Alternative(x))
    {
          case 0:
D_Mbitmap_T1(Part(x,2));
            Free(x,3);
            break;
          case 1:
            Free(x,1);
            break;
    };
}

int D_Mbitmap_T1(x)
value x;
{
#ifdef NULL_CHECK
  if (x==NULL) return;
#endif
  if (DecrRefs(x) < 0)
    XD_Mbitmap_T1(x);
}


/*
** PROTOTYPES
*/

_PROTOTYPE(int Mbitmap_P_new_BITMAP,(value *P0));
_PROTOTYPE(int Mbitmap_P_new_INT_BITMAP,(value P0,value *P1));
_PROTOTYPE(int Mbitmap_P_new_INT_INT_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_exclude_BITMAP_BITMAP_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_or_BITMAP_BITMAP_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_and_BITMAP_BITMAP_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_equal_BITMAP_BITMAP,(value P0,value P1));
_PROTOTYPE(int Mbitmap_P_is_set_BITMAP_INT,(value P0,value P1));
_PROTOTYPE(int Mbitmap_P_is_empty_BITMAP,(value P0));
_PROTOTYPE(int Mbitmap_P_clear_bit_BITMAP_INT_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_set_bit_BITMAP_INT_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_write_BITMAP,(value P0));
_PROTOTYPE(int Mbitmap_P_set_range_INT_INT_BITS_BITS,(value P0,value P1,value P2,value *P3));
_PROTOTYPE(int Mbitmap_P_is_not_empty_BITMAP,(value P0));
_PROTOTYPE(int Mbitmap_P_set_BITMAP_INT_BITMAP,(value P0,value P1,value *P2));
_PROTOTYPE(int Mbitmap_P_write_INT_BITMAP,(value P0,value P1));
_PROTOTYPE(int Mbitmap_P_write_INT_INT_BITS,(value P0,value P1,value P2));


/*
**EXTERNAL PROTOTYPES**
*/

_PROTOTYPE(extern int E1_open_input_file_TEXT_FILE,(value P0,value *P1));
_PROTOTYPE(extern int E2_open_output_file_TEXT_FILE,(value P0,value *P1));
_PROTOTYPE(extern int E3_open_standard_output_FILE,(value *P0));
_PROTOTYPE(extern int E4_open_standard_error_FILE,(value *P0));
_PROTOTYPE(extern int E5_open_standard_input_FILE,(value *P0));
_PROTOTYPE(extern int E8_pipe_to_command_TEXT_FILE,(value P0,value *P1));
_PROTOTYPE(extern int E28_pipe_from_command_TEXT_FILE,(value P0,value *P1));
_PROTOTYPE(extern int E9_close_pipe_FILE,(value P0));
_PROTOTYPE(extern int E6_close_FILE,(value P0));
_PROTOTYPE(extern int E7_seek_FILE_INT,(value P0,value P1));
_PROTOTYPE(extern int E10_write_TEXT,(value P0));
_PROTOTYPE(extern int E11_write_INT,(value P0));
_PROTOTYPE(extern int E12_write_FILE_TEXT,(value P0,value P1));
_PROTOTYPE(extern int E13_write_FILE_INT,(value P0,value P1));
_PROTOTYPE(extern int E14_formatted_write_FILE_FORMAT,(value P0,value P1));
_PROTOTYPE(extern int E15_write_char_FILE_INT,(value P0,value P1));
_PROTOTYPE(extern int E16_write_char_INT,(value P0));
_PROTOTYPE(extern int E20_trace_TEXT,(value P0));
_PROTOTYPE(extern int E21_trace_INT,(value P0));
_PROTOTYPE(extern int E22_formatted_trace_FILE_FORMAT,(value P0,value P1));
_PROTOTYPE(extern int E30_read_line_TEXT,(value *P0));
_PROTOTYPE(extern int E31_read_line_FILE_TEXT,(value P0,value *P1));
_PROTOTYPE(extern int E32_read_char_FILE_INT,(value P0,value *P1));
_PROTOTYPE(extern int E33_read_char_INT,(value *P0));
_PROTOTYPE(extern int E40_less_INT_INT,(value P0,value P1));
_PROTOTYPE(extern int E41_lesseq_INT_INT,(value P0,value P1));
_PROTOTYPE(extern int E42_greater_INT_INT,(value P0,value P1));
_PROTOTYPE(extern int E43_greatereq_INT_INT,(value P0,value P1));
_PROTOTYPE(extern int E58_length_TEXT_INT,(value P0,value *P1));
_PROTOTYPE(extern int E51_extract_TEXT_INT_INT_TEXT,(value P0,value P1,value P2,value *P3));
_PROTOTYPE(extern int E52_is_subtext_TEXT_INT_TEXT,(value P0,value *P1,value P2));
_PROTOTYPE(extern int E53_between_TEXT_INT_TEXT_TEXT,(value P0,value P1,value P2,value P3));
_PROTOTYPE(extern int E54_not_between_TEXT_INT_TEXT_TEXT,(value P0,value P1,value P2,value P3));
_PROTOTYPE(extern int E55_before_TEXT_TEXT,(value P0,value P1));
_PROTOTYPE(extern int E56_is_prefix_TEXT_TEXT_TEXT,(value P0,value P1,value *P2));
_PROTOTYPE(extern int E57_prefix_TEXT_INT_TEXT_TEXT,(value P0,value P1,value *P2,value *P3));
_PROTOTYPE(extern int E59_asciicode_TEXT_INT_INT,(value P0,value P1,value *P2));
_PROTOTYPE(extern int E60_bindec_INT_TEXT,(value P0,value *P1));
_PROTOTYPE(extern int E61_decbin_TEXT_INT,(value P0,value *P1));
_PROTOTYPE(extern int E70_hash_TEXT_INT_INT,(value P0,value P1,value *P2));
_PROTOTYPE(extern int E80_command_arg_INT_TEXT,(value P0,value *P1));
_PROTOTYPE(extern int E81_exit_INT,(value P0));
_PROTOTYPE(extern int E82_get_from_environment_TEXT_TEXT,(value P0,value *P1));
_PROTOTYPE(extern int E83_time_INT,(value *P0));
_PROTOTYPE(extern int E85_file_date_TEXT_INT,(value P0,value *P1));
_PROTOTYPE(extern int E84_execute_TEXT,(value P0));
_PROTOTYPE(extern int E200_get_key_TEXT,(value *P0));

/*
** CODE
*/

int Mbitmap_P_new_BITMAP(P0)
value *P0;
{
  value L0;
  L0 = G_bitmap_BITMAP_NR79;
  *P0 = L0;
  ATTACH(L0);
  return 1;
}

int Mbitmap_P_new_INT_BITMAP(P0,P1)
value P0;
value *P1;
{
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = C_INT(32);
  if (!E40_less_INT_INT(L0,L1)) goto LAB1;
  L2 = C_INT(1);
  L3 = C_INT(Int(L2) << Int(L0));
  Create(&L4,0,2);
  *(value *)(L4+1) = L3;
  L5 = G_bitmap_BITMAP_NR80;
  *(value *)(L4+2) = L5;
  ATTACH(L5);
  *P1 = L4;
  return 1;
LAB1:
  L6 = C_INT(32);
  L7 = C_INT(Int(L0) - Int(L6));
  Mbitmap_P_new_INT_BITMAP(L7,&L8);
  Create(&L9,0,2);
  L10 = C_INT(0);
  *(value *)(L9+1) = L10;
  *(value *)(L9+2) = L8;
  *P1 = L9;
  return 1;
}

int Mbitmap_P_new_INT_INT_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L22;
  value L21;
  value L20;
  value L19;
  value L18;
  value L17;
  value L16;
  value L15;
  value L14;
  value L13;
  value L12;
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  L2 = C_INT(32);
  if (!E40_less_INT_INT(L0,L2)) goto LAB3;
  L19 = L0;
  L20 = L1;
  L21 = C_INT(0);
  Mbitmap_P_set_range_INT_INT_BITS_BITS(L19,L20,L21,&L22);
  L3 = L22;
LAB137:
  L4 = C_INT(32);
  if (!E40_less_INT_INT(L1,L4)) goto LAB5;
  Create(&L5,0,2);
  *(value *)(L5+1) = L3;
  L6 = G_bitmap_BITMAP_NR81;
  *(value *)(L5+2) = L6;
  ATTACH(L6);
  *P2 = L5;
  return 1;
LAB5:
  L7 = C_INT(0);
  L8 = C_INT(32);
  L9 = C_INT(Int(L1) - Int(L8));
  Mbitmap_P_new_INT_INT_BITMAP(L7,L9,&L10);
  Create(&L11,0,2);
  *(value *)(L11+1) = L3;
  *(value *)(L11+2) = L10;
  *P2 = L11;
  return 1;
LAB3:
  L12 = C_INT(32);
  L13 = C_INT(Int(L0) - Int(L12));
  L14 = C_INT(32);
  L15 = C_INT(Int(L1) - Int(L14));
  Mbitmap_P_new_INT_INT_BITMAP(L13,L15,&L16);
  Create(&L17,0,2);
  L18 = C_INT(0);
  *(value *)(L17+1) = L18;
  *(value *)(L17+2) = L16;
  *P2 = L17;
  return 1;
}

int Mbitmap_P_exclude_BITMAP_BITMAP_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  switch (Alternative(L0)) {
  case 1: goto LAB6;
  default: goto LAB8;
  };
LAB6:
  L2 = G_bitmap_BITMAP_NR82;
  *P2 = L2;
  ATTACH(L2);
  return 1;
LAB8:
  switch (Alternative(L1)) {
  case 1: goto LAB9;
  default: goto LAB11;
  };
LAB9:
  *P2 = L0;
  ATTACH(L0);
  return 1;
LAB11:
  switch (Alternative(L0)) {
  case 0: goto LAB12;
  default: goto LAB14;
  };
LAB12:
  L3 = (value)(L0[1]);
  L4 = (value)(L0[2]);
  switch (Alternative(L1)) {
  case 0: goto LAB15;
  default: goto LAB14;
  };
LAB15:
  L5 = (value)(L1[1]);
  L6 = (value)(L1[2]);
  Mbitmap_P_exclude_BITMAP_BITMAP_BITMAP(L4,L6,&L7);
  L8 = C_INT( ~ Int(L5));
  L9 = C_INT(Int(L3) & Int(L8));
  Create(&L10,0,2);
  *(value *)(L10+1) = L9;
  *(value *)(L10+2) = L7;
  *P2 = L10;
  return 1;
LAB14:
  Abort(103, module_name);
}

int Mbitmap_P_or_BITMAP_BITMAP_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  switch (Alternative(L0)) {
  case 1: goto LAB18;
  default: goto LAB20;
  };
LAB18:
  *P2 = L1;
  ATTACH(L1);
  return 1;
LAB20:
  switch (Alternative(L1)) {
  case 1: goto LAB21;
  default: goto LAB23;
  };
LAB21:
  *P2 = L0;
  ATTACH(L0);
  return 1;
LAB23:
  switch (Alternative(L0)) {
  case 0: goto LAB24;
  default: goto LAB26;
  };
LAB24:
  L2 = (value)(L0[1]);
  L3 = (value)(L0[2]);
  switch (Alternative(L1)) {
  case 0: goto LAB27;
  default: goto LAB26;
  };
LAB27:
  L4 = (value)(L1[1]);
  L5 = (value)(L1[2]);
  Mbitmap_P_or_BITMAP_BITMAP_BITMAP(L3,L5,&L6);
  L7 = C_INT(Int(L2) | Int(L4));
  Create(&L8,0,2);
  *(value *)(L8+1) = L7;
  *(value *)(L8+2) = L6;
  *P2 = L8;
  return 1;
LAB26:
  Abort(91, module_name);
}

int Mbitmap_P_and_BITMAP_BITMAP_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  switch (Alternative(L0)) {
  case 0: goto LAB30;
  default: goto LAB32;
  };
LAB30:
  L2 = (value)(L0[1]);
  L3 = (value)(L0[2]);
  switch (Alternative(L1)) {
  case 0: goto LAB33;
  default: goto LAB32;
  };
LAB33:
  L4 = (value)(L1[1]);
  L5 = (value)(L1[2]);
  Mbitmap_P_and_BITMAP_BITMAP_BITMAP(L3,L5,&L6);
  L7 = C_INT(Int(L2) & Int(L4));
  Create(&L8,0,2);
  *(value *)(L8+1) = L7;
  *(value *)(L8+2) = L6;
  *P2 = L8;
  return 1;
LAB32:
  L9 = G_bitmap_BITMAP_NR83;
  *P2 = L9;
  ATTACH(L9);
  return 1;
}

int Mbitmap_P_equal_BITMAP_BITMAP(P0,P1)
value P0;
value P1;
{
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
LAB165:
  switch (Alternative(L0)) {
  case 1: goto LAB36;
  default: goto LAB38;
  };
LAB36:
  L6 = L1;
LAB140:
  switch (Alternative(L6)) {
  case 1: goto LAB139;
  case 0: goto LAB144;
  default: goto LAB38;
  };
LAB144:
  L7 = (value)(L6[1]);
  L8 = (value)(L6[2]);
  switch (Int(L7)) {
  case 0: goto LAB146;
  default: goto LAB38;
  };
LAB146:
  L6 = L8;
  goto LAB140;
LAB139:
  return 1;
LAB38:
  switch (Alternative(L1)) {
  case 1: goto LAB41;
  default: goto LAB43;
  };
LAB41:
  L9 = L0;
LAB153:
  switch (Alternative(L9)) {
  case 1: goto LAB152;
  case 0: goto LAB157;
  default: goto LAB43;
  };
LAB157:
  L10 = (value)(L9[1]);
  L11 = (value)(L9[2]);
  switch (Int(L10)) {
  case 0: goto LAB159;
  default: goto LAB43;
  };
LAB159:
  L9 = L11;
  goto LAB153;
LAB152:
  return 1;
LAB43:
  switch (Alternative(L0)) {
  case 0: goto LAB46;
  default: goto LAB48;
  };
LAB46:
  L2 = (value)(L0[1]);
  L3 = (value)(L0[2]);
  switch (Alternative(L1)) {
  case 0: goto LAB49;
  default: goto LAB48;
  };
LAB49:
  L4 = (value)(L1[1]);
  L5 = (value)(L1[2]);
  if (!(L2 == L4)) goto LAB48;
  L1 = L5;
  L0 = L3;
  goto LAB165;
LAB48:
  return 0;
}

int Mbitmap_P_is_set_BITMAP_INT(P0,P1)
value P0;
value P1;
{
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
LAB166:
  L2 = C_INT(32);
  if (!E40_less_INT_INT(L1,L2)) goto LAB57;
  switch (Alternative(L0)) {
  case 1: goto LAB58;
  case 0: goto LAB61;
  default: goto LAB63;
  };
LAB58:
  return 0;
LAB61:
  L3 = (value)(L0[1]);
  L4 = (value)(L0[2]);
  L5 = C_INT(1);
  L6 = C_INT(Int(L5) << Int(L1));
  L7 = C_INT(Int(L3) & Int(L6));
  switch (Int(L7)) {
  case 0: goto LAB64;
  default: goto LAB66;
  };
LAB64:
  return 0;
LAB66:
  return 1;
LAB63:
  Abort(168, module_name);
LAB57:
  switch (Alternative(L0)) {
  case 0: goto LAB67;
  default: goto LAB69;
  };
LAB67:
  L8 = (value)(L0[1]);
  L9 = (value)(L0[2]);
  L10 = C_INT(32);
  L11 = C_INT(Int(L1) - Int(L10));
  L1 = L11;
  L0 = L9;
  goto LAB166;
LAB69:
  return 0;
}

int Mbitmap_P_is_empty_BITMAP(P0)
value P0;
{
  value L2;
  value L1;
  value L0;
  L0 = P0;
LAB138:
  switch (Alternative(L0)) {
  case 1: goto LAB72;
  case 0: goto LAB75;
  default: goto LAB77;
  };
LAB72:
  return 1;
LAB75:
  L1 = (value)(L0[1]);
  L2 = (value)(L0[2]);
  switch (Int(L1)) {
  case 0: goto LAB78;
  default: goto LAB77;
  };
LAB78:
  L0 = L2;
  goto LAB138;
LAB77:
  return 0;
}

int Mbitmap_P_clear_bit_BITMAP_INT_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L14;
  value L13;
  value L12;
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  switch (Alternative(L0)) {
  case 1: goto LAB83;
  case 0: goto LAB86;
  default: goto LAB88;
  };
LAB83:
  L2 = G_bitmap_BITMAP_NR84;
  *P2 = L2;
  ATTACH(L2);
  return 1;
LAB86:
  L3 = (value)(L0[1]);
  L4 = (value)(L0[2]);
  L5 = C_INT(32);
  if (!E40_less_INT_INT(L1,L5)) goto LAB90;
  L6 = C_INT(1);
  L7 = C_INT(Int(L6) << Int(L1));
  L8 = C_INT( ~ Int(L7));
  L9 = C_INT(Int(L8) & Int(L3));
  Create(&L10,0,2);
  *(value *)(L10+1) = L9;
  *(value *)(L10+2) = L4;
  ATTACH(L4);
  *P2 = L10;
  return 1;
LAB90:
  L11 = C_INT(32);
  L12 = C_INT(Int(L1) - Int(L11));
  Mbitmap_P_clear_bit_BITMAP_INT_BITMAP(L4,L12,&L13);
  Create(&L14,0,2);
  *(value *)(L14+1) = L3;
  *(value *)(L14+2) = L13;
  *P2 = L14;
  return 1;
LAB88:
  Abort(141, module_name);
}

int Mbitmap_P_set_bit_BITMAP_INT_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L23;
  value L22;
  value L21;
  value L20;
  value L19;
  value L18;
  value L17;
  value L16;
  value L15;
  value L14;
  value L13;
  value L12;
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  L2 = C_INT(32);
  if (!E40_less_INT_INT(L1,L2)) goto LAB92;
  switch (Alternative(L0)) {
  case 1: goto LAB93;
  case 0: goto LAB96;
  default: goto LAB98;
  };
LAB93:
  L3 = C_INT(1);
  L4 = C_INT(Int(L3) << Int(L1));
  Create(&L5,0,2);
  *(value *)(L5+1) = L4;
  L6 = G_bitmap_BITMAP_NR85;
  *(value *)(L5+2) = L6;
  ATTACH(L6);
  *P2 = L5;
  return 1;
LAB96:
  L7 = (value)(L0[1]);
  L8 = (value)(L0[2]);
  L9 = C_INT(1);
  L10 = C_INT(Int(L9) << Int(L1));
  L11 = C_INT(Int(L10) | Int(L7));
  Create(&L12,0,2);
  *(value *)(L12+1) = L11;
  *(value *)(L12+2) = L8;
  ATTACH(L8);
  *P2 = L12;
  return 1;
LAB98:
  Abort(151, module_name);
LAB92:
  switch (Alternative(L0)) {
  case 1: goto LAB99;
  case 0: goto LAB102;
  default: goto LAB104;
  };
LAB99:
  L13 = C_INT(32);
  L14 = C_INT(Int(L1) - Int(L13));
  Mbitmap_P_set_bit_BITMAP_INT_BITMAP(L0,L14,&L15);
  Create(&L16,0,2);
  L17 = C_INT(0);
  *(value *)(L16+1) = L17;
  *(value *)(L16+2) = L15;
  *P2 = L16;
  return 1;
LAB102:
  L18 = (value)(L0[1]);
  L19 = (value)(L0[2]);
  L20 = C_INT(32);
  L21 = C_INT(Int(L1) - Int(L20));
  Mbitmap_P_set_bit_BITMAP_INT_BITMAP(L19,L21,&L22);
  Create(&L23,0,2);
  *(value *)(L23+1) = L18;
  *(value *)(L23+2) = L22;
  *P2 = L23;
  return 1;
LAB104:
  Abort(158, module_name);
}

int Mbitmap_P_write_BITMAP(P0)
value P0;
{
  value L1;
  value L0;
  L0 = P0;
  L1 = C_INT(0);
  Mbitmap_P_write_INT_BITMAP(L1,L0);
  return 1;
}

int Mbitmap_P_set_range_INT_INT_BITS_BITS(P0,P1,P2,P3)
value P0;
value P1;
value P2;
value *P3;
{
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  L2 = P2;
LAB136:
  L3 = C_INT(32);
  if (!E40_less_INT_INT(L0,L3)) goto LAB106;
  if (!E41_lesseq_INT_INT(L0,L1)) goto LAB106;
  L4 = C_INT(1);
  L5 = C_INT(Int(L4) << Int(L0));
  L6 = C_INT(Int(L5) | Int(L2));
  L7 = C_INT(1);
  L8 = C_INT(Int(L0) + Int(L7));
  L2 = L6;
  L0 = L8;
  goto LAB136;
LAB106:
  *P3 = L2;
  return 1;
}

int Mbitmap_P_is_not_empty_BITMAP(P0)
value P0;
{
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = L0;
LAB170:
  switch (Alternative(L1)) {
  case 1: goto LAB169;
  case 0: goto LAB174;
  default: goto LAB110;
  };
LAB174:
  L2 = (value)(L1[1]);
  L3 = (value)(L1[2]);
  switch (Int(L2)) {
  case 0: goto LAB176;
  default: goto LAB110;
  };
LAB176:
  L1 = L3;
  goto LAB170;
LAB169:
  return 0;
LAB110:
  return 1;
}

int Mbitmap_P_set_BITMAP_INT_BITMAP(P0,P1,P2)
value P0;
value P1;
value *P2;
{
  value L22;
  value L21;
  value L20;
  value L19;
  value L18;
  value L17;
  value L16;
  value L15;
  value L14;
  value L13;
  value L12;
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  L2 = C_INT(32);
  if (!E40_less_INT_INT(L1,L2)) goto LAB112;
  switch (Alternative(L0)) {
  case 1: goto LAB113;
  case 0: goto LAB116;
  default: goto LAB118;
  };
LAB113:
  L3 = C_INT(1);
  L4 = C_INT(Int(L3) << Int(L1));
  Create(&L5,0,2);
  *(value *)(L5+1) = L4;
  *(value *)(L5+2) = L0;
  ATTACH(L0);
  *P2 = L5;
  return 1;
LAB116:
  L6 = (value)(L0[1]);
  L7 = (value)(L0[2]);
  L8 = C_INT(1);
  L9 = C_INT(Int(L8) << Int(L1));
  L10 = C_INT(Int(L9) | Int(L6));
  Create(&L11,0,2);
  *(value *)(L11+1) = L10;
  *(value *)(L11+2) = L7;
  ATTACH(L7);
  *P2 = L11;
  return 1;
LAB118:
  Abort(123, module_name);
LAB112:
  switch (Alternative(L0)) {
  case 1: goto LAB119;
  case 0: goto LAB122;
  default: goto LAB124;
  };
LAB119:
  L12 = C_INT(32);
  L13 = C_INT(Int(L1) - Int(L12));
  Mbitmap_P_set_BITMAP_INT_BITMAP(L0,L13,&L14);
  Create(&L15,0,2);
  L16 = C_INT(0);
  *(value *)(L15+1) = L16;
  *(value *)(L15+2) = L14;
  *P2 = L15;
  return 1;
LAB122:
  L17 = (value)(L0[1]);
  L18 = (value)(L0[2]);
  L19 = C_INT(32);
  L20 = C_INT(Int(L1) - Int(L19));
  Mbitmap_P_set_BITMAP_INT_BITMAP(L18,L20,&L21);
  Create(&L22,0,2);
  *(value *)(L22+1) = L17;
  *(value *)(L22+2) = L21;
  *P2 = L22;
  return 1;
LAB124:
  Abort(130, module_name);
}

int Mbitmap_P_write_INT_BITMAP(P0,P1)
value P0;
value P1;
{
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
LAB168:
  switch (Alternative(L1)) {
  case 0: goto LAB125;
  case 1: goto LAB128;
  default: goto LAB130;
  };
LAB125:
  L2 = (value)(L1[1]);
  L3 = (value)(L1[2]);
  L4 = C_INT(0);
  Mbitmap_P_write_INT_INT_BITS(L4,L0,L2);
  L5 = C_INT(32);
  L6 = C_INT(Int(L0) + Int(L5));
  L1 = L3;
  L0 = L6;
  goto LAB168;
LAB128:
  return 1;
LAB130:
  Abort(184, module_name);
}

int Mbitmap_P_write_INT_INT_BITS(P0,P1,P2)
value P0;
value P1;
value P2;
{
  value L12;
  value L11;
  value L10;
  value L9;
  value L8;
  value L7;
  value L6;
  value L5;
  value L4;
  value L3;
  value L2;
  value L1;
  value L0;
  L0 = P0;
  L1 = P1;
  L2 = P2;
LAB167:
  L3 = C_INT(32);
  if (!E40_less_INT_INT(L0,L3)) goto LAB132;
  L4 = C_INT(1);
  L5 = C_INT(Int(L4) << Int(L0));
  L6 = C_INT(Int(L5) & Int(L2));
  switch (Int(L6)) {
  case 0: goto LAB133;
  default: goto LAB135;
  };
LAB133:
  L7 = C_INT(1);
  L8 = C_INT(Int(L0) + Int(L7));
  L0 = L8;
  goto LAB167;
LAB135:
  L9 = G_bitmap_TEXT_NR86;
  E10_write_TEXT(L9);
  L10 = C_INT(Int(L0) + Int(L1));
  E11_write_INT(L10);
  L11 = C_INT(1);
  L12 = C_INT(Int(L0) + Int(L11));
  L0 = L12;
  goto LAB167;
LAB132:
  return 1;
}

